#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <stdio.h>
#include <malloc.h>
#include "glATI.h"

#define GTC_ID (('C'<<16)+('T'<<8)+'G')

typedef struct
{
	int ID;
	unsigned int Width;
	unsigned int Height;
	unsigned int Format;
	unsigned int Size;
	unsigned char *Data;
} GTC_t;

PFNGLCOMPRESSEDTEXIMAGE2DARBPROC glCompressedTexImage2DARB=NULL;

unsigned int GTC_UploadImage(char *file)
{
	FILE *stream;
	unsigned int TextureID;
	GTC_t GTC;

	if(glCompressedTexImage2DARB==NULL)
		glCompressedTexImage2DARB=(PFNGLCOMPRESSEDTEXIMAGE2DARBPROC)wglGetProcAddress("glCompressedTexImage2DARB");

	if((stream=fopen(file, "rb"))==NULL)
		return 0;

	fread(&GTC.ID, sizeof(int), 1, stream);

	if(GTC.ID!=GTC_ID)
	{
		fclose(stream);
		return 0;
	}

	fread(&GTC.Width, sizeof(unsigned int), 1, stream);
	fread(&GTC.Height, sizeof(unsigned int), 1, stream);
	fread(&GTC.Format, sizeof(unsigned int), 1, stream);
	fread(&GTC.Size, sizeof(unsigned int), 1, stream);

	GTC.Data=malloc(GTC.Size);
	fread(GTC.Data, sizeof(unsigned char), GTC.Size, stream);

	fclose(stream);

	glGenTextures(1, &TextureID);
	glBindTexture(GL_TEXTURE_2D, TextureID);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glCompressedTexImage2DARB(GL_TEXTURE_2D, 0, GTC.Format, GTC.Width, GTC.Height, 0, GTC.Size, GTC.Data);

	free(GTC.Data);

	return TextureID;
}